/*
################################
#POSTGRESTATS ENTERPRISE LICENSE
################################
Copyright 2013 NWLYNX <http://www.nwlynx.com/>.

This file is part of PostgreStats Enterprise <http://www.postgrestats.com/>.

PostgreStats Enterprise is free software: you can redistribute it and/or modify it under the terms of the GNU General Public 
License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

PostgreStats Enterprise is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
*/

//################
//GETXMLHTTPOBJECT
//################
function GetXmlHttpObject()
{
	//INITIATE XMLHTTP VAR
	var xmlHttp = null;
	
	//ATTEMPT TO CREATE FOR FIREFOX, OPERA, SAFARI
	try
	{
		xmlHttp = new XMLHttpRequest();
	} 
	
	//ATTEMPT TO CREATE FOR INTERNET EXPLORER
	catch (e)
	{
		try
		{
			xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
		}
		catch (e)
		{
			xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
		}
	}
	
	//RETURN THE RESULT
	return xmlHttp;
}

//#########
//STAT_VIEW
//#########
function stat_view(view_type)
{
	//FIRST CLEAR THE STAT VIEW
	clear_stat_views();

	//VIEW SET-UP
	if(view_type == 1)
	{
		//RESET VIEW
		var view_setup = document.getElementById('view_setup');
		view_setup.style.display = '';

		//EMPTY USER VAR
		var ps_user = window.document.getElementById('ps_user');
		ps_user.value = '';

		//EMPTY & HIDE SCRIPT GEN RESULTS
		var script_gen_result = document.getElementById('script_gen_result');
		script_gen_result.innerHTML = '';
		script_gen_result.style.display = 'none';
	}
	
	//VIEW ADMIN
	if(view_type == 2)
	{
		//RESET VIEW
		var view_admin = document.getElementById('view_admin');
		view_admin.style.display = '';

		//RESET USER VARS
		var ps_admin_new_user = window.document.getElementById('ps_admin_new_user');
		var ps_admin_pass = window.document.getElementById('ps_admin_pass');
		ps_admin_new_user.value = '';
		ps_admin_pass.value = '';

		// RESET AND HIDE USER RESULT
		var admin_user_reset_result = document.getElementById('admin_user_reset_result');
		admin_user_reset_result.innerHTML = '';
		admin_user_reset_result.style.display = 'none';

		//RESET PASS VARS
		var ps_admin_old_pass = window.document.getElementById('ps_admin_old_pass');
		var ps_admin_new_pass_1 = window.document.getElementById('ps_admin_new_pass_1');
		var ps_admin_new_pass_2 = window.document.getElementById('ps_admin_new_pass_2');
		ps_admin_old_pass.value = '';
		ps_admin_new_pass_1.value = '';
		ps_admin_new_pass_2.value = '';

		// RESET AND HIDE PASS RESULT
		var admin_pass_reset_result = document.getElementById('admin_pass_reset_result');
		admin_pass_reset_result.innerHTML = '';
		admin_pass_reset_result.style.display = 'none';		
	}
	
	//VIEW SERVERS & DBS
	if(view_type == 3)
	{
		//RESET VIEW
		var view_servers_dbs = document.getElementById('view_servers_dbs');
		view_servers_dbs.style.display = '';

		//RESET AND HIDE SERVER RESULT
		var server_result = document.getElementById('server_result');
		server_result.innerHTML = '';
		server_result.style.display = 'none';

		//RESET SERVER INSERT VARS
		var ps_add_server_name = window.document.getElementById('ps_add_server_name');
		var ps_add_server_host = window.document.getElementById('ps_add_server_host');
		var ps_add_server_port = window.document.getElementById('ps_add_server_port');
		ps_add_server_name.value = '';
		ps_add_server_host.value = '';
		ps_add_server_port.value = '';

		//RESET AND HIDE SERVER INSERT RESULT
		var server_insert_result = document.getElementById('server_insert_result');
		server_insert_result.innerHTML = '';
		server_insert_result.style.display = 'none';

		//REFRESH OUR SERVER LIST NOW
		server_list_refresh();
	}

	//VIEW STATS MONTHLY SNAPSHOT
	if(view_type == 4)
	{
		//GET OUR VIEW IDS
		var monthly_snapshot_data = document.getElementById('monthly_snapshot_data');
		var monthly_snapshot_error = document.getElementById('monthly_snapshot_error');
		var monthly_snapshot = document.getElementById('monthly_snapshot');

		//RESET THE DATA VIEW
		monthly_snapshot_data.style.display = '';
		monthly_snapshot.style.display = '';

		//RESET THE NAV ERROR VIEW
		monthly_snapshot_error.style.display = 'none';
		monthly_snapshot_error.innerHTML = '';
	}

	//VIEW STATS DAILY
	if(view_type == 5)
	{
		//GET OUR VIEW IDS
		var daily_data = document.getElementById('daily_data');
		var daily_error = document.getElementById('daily_error');
		var daily = document.getElementById('daily');

		//RESET THE DATA VIEW
		daily_data.style.display = '';
		daily.style.display = '';

		//RESET THE NAV ERROR VIEW
		daily_error.style.display = 'none';
		daily_error.innerHTML = '';
	}

	//VIEW STATS VERSUS
	if(view_type == 6)
	{
		//GET OUR VIEW IDS
		var versus_data = document.getElementById('versus_data');
		var versus_error = document.getElementById('versus_error');
		var versus = document.getElementById('versus');

		//RESET THE DATA VIEW
		versus_data.style.display = '';
		versus.style.display = '';

		//RESET THE NAV ERROR VIEW
		versus_error.style.display = 'none';
		versus_error.innerHTML = '';
	}

	//VIEW STATS WEEKLY
	if(view_type == 7)
	{
		//GET OUR VIEW IDS
		var weekly_data = document.getElementById('weekly_data');
		var weekly_error = document.getElementById('weekly_error');
		var weekly = document.getElementById('weekly');

		//RESET THE DATA VIEW
		weekly_data.style.display = '';
		weekly.style.display = '';

		//RESET THE NAV ERROR VIEW
		weekly_error.style.display = 'none';
		weekly_error.innerHTML = '';
	}

	//VIEW STATS YEARLY SNAPSHOT
	if(view_type == 8)
	{
		//GET OUR VIEW IDS
		var yearly_data = document.getElementById('yearly_data');
		var yearly_error = document.getElementById('yearly_error');
		var yearly = document.getElementById('yearly');

		//RESET THE DATA VIEW
		yearly_data.style.display = '';
		yearly.style.display = '';

		//RESET THE NAV ERROR VIEW
		yearly_error.style.display = 'none';
		yearly_error.innerHTML = '';
	}
}

//################
//CLEAR_STAT_VIEWS
//################
function clear_stat_views() 
{
	//GET OUR VIEW IDS
	var view_setup = document.getElementById('view_setup');
	var view_admin = document.getElementById('view_admin');
	var view_servers_dbs = document.getElementById('view_servers_dbs');
	var view_server_update = document.getElementById('view_server_update');
	var view_db_insert = document.getElementById('view_db_insert');
	var view_db_list = document.getElementById('view_db_list');
	var monthly_snapshot = document.getElementById('monthly_snapshot');
	var daily = document.getElementById('daily');
	var versus = document.getElementById('versus');
	var weekly = document.getElementById('weekly');
	var yearly = document.getElementById('yearly');
	var mem = document.getElementById('mem');
	var welcome = document.getElementById('welcome');

	//CLEAR ALL MAJOR VIEWS
	view_setup.style.display = 'none';
	view_admin.style.display = 'none';
	view_servers_dbs.style.display = 'none';
	view_server_update.style.display = 'none';
	view_db_insert.style.display = 'none';
	view_db_list.style.display = 'none';
	monthly_snapshot.style.display = 'none';
	daily.style.display = 'none';
	versus.style.display = 'none';
	weekly.style.display = 'none';
	yearly.style.display = 'none';
	mem.style.display = 'none';
	welcome.style.display = 'none';
}

//####################
//GEN_PS_CREATE_SCRIPT
//####################
function gen_ps_create_script()
{
	//GET OUR IDS
	var ps_user = window.document.getElementById('ps_user').value;
	var script_gen_result = document.getElementById('script_gen_result');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY AND HIDE RESULT
				script_gen_result.innerHTML = '';
				script_gen_result.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//APPLY VALUE AND MAKE VISIBLE
				script_gen_result.innerHTML = xmlHttp.responseText;
				script_gen_result.style.display = '';
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=gen_ps_create_script&ps_user=" + ps_user;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//####################
//RESET_ADMIN_PASSWORD
//####################
function reset_admin_password()
{
	//GET OUR VARS &IDS
	var ps_admin_old_pass = window.document.getElementById('ps_admin_old_pass').value;
	var ps_admin_new_pass_1 = window.document.getElementById('ps_admin_new_pass_1').value;
	var ps_admin_new_pass_2 = window.document.getElementById('ps_admin_new_pass_2').value;
	var admin_pass_reset_result = document.getElementById('admin_pass_reset_result');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY AND HIDE RESULT
				admin_pass_reset_result.innerHTML = '';
				admin_pass_reset_result.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//APPLY VALUE AND MAKE VISIBLE
				admin_pass_reset_result.innerHTML = xmlHttp.responseText;
				admin_pass_reset_result.style.display = '';
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=admin_reset_password&ps_admin_old_pass=" + ps_admin_old_pass + "&ps_admin_new_pass_1=" + ps_admin_new_pass_1 + "&ps_admin_new_pass_2=" + ps_admin_new_pass_2;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//####################
//RESET_ADMIN_USERNAME
//####################
function reset_admin_username()
{
	//GET OUR VARS &IDS
	var ps_admin_new_user = window.document.getElementById('ps_admin_new_user').value;
	var ps_admin_pass = window.document.getElementById('ps_admin_pass').value;
	var admin_user_reset_result = document.getElementById('admin_user_reset_result');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY AND HIDE RESULT
				admin_user_reset_result.innerHTML = '';
				admin_user_reset_result.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//APPLY VALUE AND MAKE VISIBLE
				admin_user_reset_result.innerHTML = xmlHttp.responseText;
				admin_user_reset_result.style.display = '';
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=admin_reset_username&ps_admin_new_user=" + ps_admin_new_user + "&ps_admin_pass=" + ps_admin_pass;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//#############
//SERVER_INSERT
//#############
function server_insert()
{
	//GET OUR VARS
	var ps_add_server_name = window.document.getElementById('ps_add_server_name').value;
	var ps_add_server_host = window.document.getElementById('ps_add_server_host').value;
	var ps_add_server_port = window.document.getElementById('ps_add_server_port').value;
	var server_insert_result = document.getElementById('server_insert_result');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();
	
	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//CLOSE SERVER & DB WINDOWS
				close_server_db_windows();

				//EMPTY AND HIDE INSERT RESULT
				server_insert_result.innerHTML = '';
				server_insert_result.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);
				var success = json_array[0];
				var response = json_array[1];

				//DISPLAY SERVER RESULT REGARDLESS OF SUCCESS
				server_insert_result.innerHTML = response;
				server_insert_result.style.display = '';

				//REFRESH SERVER LIST ON SUCCESS
				if(success == 1)
				{
					//REFRESH SERVER LIST
					server_list_refresh();
				}
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=server_insert&ps_add_server_name=" + ps_add_server_name + "&ps_add_server_host=" + ps_add_server_host + "&ps_add_server_port=" + ps_add_server_port;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//###################
//SERVER_LIST_REFRESH
//###################
function server_list_refresh()
{
	//GRAB OUT ID
	var server_list = document.getElementById('server_list');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY AND HIDE LIST DATA
				server_list.innerHTML = '';
				server_list.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//APPLY VALUES AND MAKE VISIBLE
				server_list.innerHTML = xmlHttp.responseText;
				server_list.style.display = '';
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=server_list_refresh";
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//##################
//SERVER_OPEN_UPDATE
//##################
function server_open_update()
{
	//GET SERVER ID
	var server_id = document.getElementById('server_list_dropdown').value;

	//VARS FOR THE VIEW, DATA DIV & SERVER RESULT
	var view_server_update = document.getElementById('view_server_update');
	var server_update_data = document.getElementById('server_update_data');
	var server_result = document.getElementById('server_result');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//CLOSE DB INSERT
				db_close_insert();

				//CLOSE DB LIST
				db_close_list();

				//HIDE VIEW
				view_server_update.style.display = 'none';

				//EMPTY UPDATE DATA AND HIDE
				server_update_data.innerHTML = '';
				server_update_data.style.display = 'none';

				//EMPTY SERVER RESULT AND HIDE
				server_result.style.innerHTML = '';
				server_result.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//UPDATE SERVER DATA
				server_update_data.innerHTML = xmlHttp.responseText;

				//SHOW THE VIEW & DATA
				view_server_update.style.display = '';
				server_update_data.style.display = '';
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=server_open_update&server_id=" + server_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//###################
//SERVER_CLOSE_UPDATE
//###################
function server_close_update()
{
	//HIDE THE MAIN VIEW
	var view_server_update = document.getElementById('view_server_update');
	view_server_update.style.display = 'none';

	//EMPTY AND HIDE THE SERVER UPDATE DATA	
	var server_update_data = document.getElementById('server_update_data');
	server_update_data.innerHTML = '';
	server_update_data.style.display = 'none';

	//EMPTY AND HIDE THE SERVER RESULT
	var server_result = document.getElementById('server_result');
	server_result.innerHTML = '';
	server_result.style.display = 'none';
}

//#############
//SERVER_DELETE
//#############
function server_delete()
{
	//GET SERVER ID	AND RESULT VARS
	var server_id = document.getElementById('server_list_dropdown').value;
	var server_result = document.getElementById('server_result');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//CLOSE SERVER & DB WINDOWS
				close_server_db_windows();

				//EMPTY AND HIDE SERVER RESULT
				server_result.innerHTML = '';
				server_result.style.display = 'none';
			}
			
			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//APPLY VALUES AND MAKE VISIBLE
				server_result.innerHTML = xmlHttp.responseText;
				server_result.style.display = '';

				//REFRESH SERVER LIST
				server_list_refresh();
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=server_delete&server_id=" + server_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//#############
//SERVER_UPDATE
//#############
function server_update(server_id)
{
	//GRAB OUR UPDATE AND VIEW IDS
	var ps_update_server_name = document.getElementById('ps_update_server_name').value;
	var ps_update_server_host = document.getElementById('ps_update_server_host').value;
	var ps_update_server_port = document.getElementById('ps_update_server_port').value;
	var ps_update_server_pause = document.getElementById('ps_update_server_pause');
	var server_result = document.getElementById('server_result');
	var server_update_result = document.getElementById('server_update_result');
	
	//HANDLE SERVER PAUSE VALUE
	if(ps_update_server_pause.checked === true) { ps_update_server_pause = 2; }
	else { ps_update_server_pause = 1; }

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY AND HIDE SERVER RESULT
				server_result.innerHTML = '';
				server_result.style.display = 'none';

				//EMPTY AND HIDE SERVER UPDATE RESULT
				server_update_result.innerHTML = '';
				server_update_result.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);
				var success = json_array[0];
				var response = json_array[1];

				if(success == 1)
				{
					//CLOSE SERVER UPDATE
					server_close_update();

					//APPLY VALUES AND MAKE VISIBLE
					server_result.innerHTML = response;
					server_result.style.display = '';

					//REFRESH SERVER LIST
					server_list_refresh();
				}
				else
				{
					server_update_result.innerHTML = response;
					server_update_result.style.display = '';
				}
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=server_update&ps_update_server_name=" + ps_update_server_name + "&ps_update_server_host=" + ps_update_server_host + "&ps_update_server_port=" + ps_update_server_port + "&ps_update_server_pause=" + ps_update_server_pause + "&server_id=" + server_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//####################
//DATABASE_OPEN_INSERT
//####################
function db_open_insert()
{
	//GET SERVER ID
	var server_id = document.getElementById('server_list_dropdown').value;

	//VARS FOR THE VIEW, DATA DIV & SERVER RESULT
	var view_db_insert = document.getElementById('view_db_insert');
	var db_insert_data = document.getElementById('db_insert_data');
	var server_result = document.getElementById('server_result');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//CLOSE SERVER & DB WINDOWS
				close_server_db_windows();

				//HIDE VIEW
				view_db_insert.style.display = 'none';
				
				//EMPTY UPDATE DATA AND HIDE
				db_insert_data.innerHTML = '';
				db_insert_data.style.display = 'none';

				//EMPTY SERVER RESULT AND HIDE
				server_result.style.innerHTML = '';
				server_result.style.display = 'none';
			}
			
			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//UPDATE SERVER DATA
				db_insert_data.innerHTML = xmlHttp.responseText;
				
				//SHOW THE VIEW & DATA
				view_db_insert.style.display = '';
				db_insert_data.style.display = '';
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=db_open_insert&server_id=" + server_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//###############
//DB_CLOSE_INSERT
//###############
function db_close_insert()
{
	//HIDE THE MAIN VIEW
	var view_db_insert = document.getElementById('view_db_insert');
	view_db_insert.style.display = 'none';

	//EMPTY AND HIDE THE DB INSERT DATA	
	var db_insert_data = document.getElementById('db_insert_data');
	db_insert_data.innerHTML = '';
	db_insert_data.style.display = 'none';

	//EMPTY AND HIDE THE SERVER RESULT
	var server_result = document.getElementById('server_result');
	server_result.innerHTML = '';
	server_result.style.display = 'none';
}

//#############
//DB_CLOSE_LIST
//#############
function db_close_list()
{
	//HIDE THE MAIN VIEW
	var view_db_list = document.getElementById('view_db_list');
	view_db_list.style.display = 'none';

	//EMPTY AND HIDE THE DB INSERT DATA	
	var db_list_data = document.getElementById('db_list_data');
	db_list_data.innerHTML = '';
	db_list_data.style.display = 'none';

	//EMPTY AND HIDE THE SERVER RESULT
	var server_result = document.getElementById('server_result');
	server_result.innerHTML = '';
	server_result.style.display = 'none';
}

//#######################
//CLOSE_SERVER_DB_WINDOWS
//#######################
function close_server_db_windows()
{
	//CLOSE THE SERVER UPDATE WINDOW
	server_close_update();

	//CLOSE THE DB INSERT WINDOW
	db_close_insert();

	//CLOSE THE DB LIST WINDOW
	db_close_list();
}

//###############
//DATABASE_INSERT
//###############
function db_insert(server_id)
{
	//GRAB OUR UPDATE AND VIEW IDS
	var ps_insert_db_name = document.getElementById('ps_insert_db_name').value;
	var ps_insert_db_user = document.getElementById('ps_insert_db_user').value;
	var ps_insert_db_pass = document.getElementById('ps_insert_db_pass').value;
	var ps_insert_db_ap = document.getElementById('ps_insert_db_ap');
	var server_result = document.getElementById('server_result');
	var db_insert_result = document.getElementById('db_insert_result');
	
	//HANDLE SERVER AUTO-POPULATE VALUE
	if(ps_insert_db_ap.checked === true) { ps_insert_db_ap = 1; }
	else { ps_insert_db_ap = 2; }

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY AND HIDE SERVER RESULT
				server_result.innerHTML = '';
				server_result.style.display = 'none';

				//EMPTY AND HIDE DATABASE INSERT RESULT
				db_insert_result.innerHTML = '';
				db_insert_result.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);
				var success = json_array[0];
				var response = json_array[1];

				if(success == 1)
				{
					//CLOSE DATABASE INSERT
					db_close_insert();

					//APPLY VALUES AND MAKE VISIBLE
					server_result.innerHTML = response;
					server_result.style.display = '';
				}
				else
				{
					db_insert_result.innerHTML = response;
					db_insert_result.style.display = '';
				}
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=db_insert&ps_insert_db_name=" + ps_insert_db_name + "&ps_insert_db_user=" + ps_insert_db_user + "&ps_insert_db_pass=" + ps_insert_db_pass + "&ps_insert_db_ap=" + ps_insert_db_ap + "&server_id=" + server_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//##################
//DATABASE_OPEN_LIST
//##################
function db_open_list()
{
	//GET SERVER ID
	var server_id = document.getElementById('server_list_dropdown').value;

	//VARS FOR THE VIEW, DATA DIV & SERVER RESULT
	var view_db_list = document.getElementById('view_db_list');
	var db_list_data = document.getElementById('db_list_data');
	var server_result = document.getElementById('server_result');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//CLOSE SERVER & DB WINDOWS
				close_server_db_windows();

				//HIDE VIEW
				view_db_list.style.display = 'none';
				
				//EMPTY UPDATE DATA AND HIDE
				db_list_data.innerHTML = '';
				db_list_data.style.display = 'none';

				//EMPTY SERVER RESULT AND HIDE
				server_result.style.innerHTML = '';
				server_result.style.display = 'none';
			}
			
			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//UPDATE SERVER DATA
				db_list_data.innerHTML = xmlHttp.responseText;
				
				//SHOW THE VIEW & DATA
				view_db_list.style.display = '';
				db_list_data.style.display = '';
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=db_open_list&server_id=" + server_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//#########
//DB_DELETE
//#########
function db_delete(server_id)
{
	//GET DB ID	AND SERVER RESULT VARS
	var db_id = document.getElementById('db_list_dropdown').value;
	var server_result = document.getElementById('server_result');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//CLOSE SERVER & DB WINDOWS
				close_server_db_windows();

				//EMPTY AND HIDE SERVER RESULT
				server_result.innerHTML = '';
				server_result.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//APPLY VALUES AND MAKE VISIBLE
				server_result.innerHTML = xmlHttp.responseText;
				server_result.style.display = '';
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=db_delete&server_id=" + server_id + "&db_id=" + db_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//#######################
//DB_INSERT_SHOW_PASS_DIV
//#######################
function db_insert_show_pass_div()
{
	//GET IDS
	var db_insert_pass_required_link = document.getElementById('db_insert_pass_required_link');
	var db_insert_pass_required_div = document.getElementById('db_insert_pass_required_div');
	db_insert_pass_required_link.style.display = 'none';
	db_insert_pass_required_div.style.display = '';
}

//#######################
//DB_INSERT_HIDE_PASS_DIV
//#######################
function db_insert_hide_pass_div()
{
	//GET IDS
	var db_insert_pass_required_link = document.getElementById('db_insert_pass_required_link');
	var db_insert_pass_required_div = document.getElementById('db_insert_pass_required_div');
	db_insert_pass_required_link.style.display = '';
	db_insert_pass_required_div.style.display = 'none';
}

//#######################
//DB_UPDATE_SHOW_PASS_DIV
//#######################
function db_update_show_pass_div()
{
	//GET IDS
	var db_update_pass_required_link = document.getElementById('db_update_pass_required_link');
	var db_update_pass_required_div = document.getElementById('db_update_pass_required_div');
	db_update_pass_required_link.style.display = 'none';
	db_update_pass_required_div.style.display = '';
}

//#######################
//DB_UPDATE_HIDE_PASS_DIV
//#######################
function db_update_hide_pass_div()
{
	//GET IDS
	var db_update_pass_required_link = document.getElementById('db_update_pass_required_link');
	var db_update_pass_required_div = document.getElementById('db_update_pass_required_div');
	db_update_pass_required_link.style.display = '';
	db_update_pass_required_div.style.display = 'none';
}

//###########
//DB_VALIDATE
//###########
function db_validate()
{
	//GRAB OUR IDS
	var server_id = document.getElementById('server_list_dropdown').value;
	var db_id = document.getElementById('db_list_dropdown').value;

	//ID FOR SERVER RESULT
	var server_result = document.getElementById('server_result');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY SERVER RESULT AND HIDE
				server_result.innerHTML = '';
				server_result.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//UPDATE SERVER RESULT AND SHOW
				server_result.innerHTML = xmlHttp.responseText;
				server_result.style.display = '';
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=db_validate&server_id=" + server_id + "&db_id=" + db_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//##############
//DB_OPEN_UPDATE
//##############
function db_open_update()
{
	//GRAB OUR VIEW IDS
	var view_db_update = document.getElementById('view_db_update');
	var db_update_data = document.getElementById('db_update_data');

	//GRAB OUR DB IDS
	var server_id = document.getElementById('server_list_dropdown').value;
	var db_id = document.getElementById('db_list_dropdown').value;

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//HIDE DB UPDATE VIEW
				view_db_update.style.display = 'none';

				//EMPTY AND HIDE THE DB DATA VAR
				db_update_data.style.innerHTML = '';
				db_update_data.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//SHOW THE VIEW
				view_db_update.style.display = '';

				//SHOW DB DATA
				db_update_data.innerHTML = xmlHttp.responseText;
				db_update_data.style.display = '';
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=db_open_update&server_id=" + server_id + "&db_id=" + db_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//###############
//DB_CLOSE_UPDATE
//###############
function db_close_update()
{
	//GRAB OUR VIEW IDS
	var view_db_update = document.getElementById('view_db_update');
	var db_update_data = document.getElementById('db_update_data');

	//CLOSE THE MAIN DB UPDATE VIEW
	view_db_update.style.display = 'none';

	//EMPTY AND HIDE UPDATE DATA
	db_update_data.innerHTML = '';
	db_update_data.style.display = 'none';
}

//#########
//DB_UPDATE
//#########
function db_update(server_id,db_id)
{
	//GRAB OUR UPDATE AND VIEW IDS
	var ps_update_db_name = document.getElementById('ps_update_db_name').value;
	var ps_update_db_user = document.getElementById('ps_update_db_user').value;
	var ps_update_db_pass = document.getElementById('ps_update_db_pass').value;
	var ps_update_db_pause = document.getElementById('ps_update_db_pause');
	var server_result = document.getElementById('server_result');
	var db_update_result = document.getElementById('db_update_result');

	//HANDLE DB PAUSE VALUE
	if(ps_update_db_pause.checked === true) { ps_update_db_pause = 2; }
	else { ps_update_db_pause = 1; }

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY AND HIDE SERVER RESULT
				server_result.innerHTML = '';
				server_result.style.display = 'none';

				//EMPTY AND HIDE DATABASE UPDATE RESULT
				db_update_result.innerHTML = '';
				db_update_result.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);
				var success = json_array[0];
				var response = json_array[1];

				if(success == 1)
				{
					//CLOSE DATABASE UPDATE
					db_close_update();

					//APPLY VALUES AND MAKE VISIBLE
					server_result.innerHTML = response;
					server_result.style.display = '';
				}
				else
				{
					db_update_result.innerHTML = response;
					db_update_result.style.display = '';
				}
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=db_update&ps_update_db_name=" + ps_update_db_name + "&ps_update_db_user=" + ps_update_db_user + "&ps_update_db_pass=" + ps_update_db_pass + "&ps_update_db_pause=" + ps_update_db_pause + "&server_id=" + server_id + "&db_id=" + db_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//#############################
//MONTHLY_SNAP_RETRIEVE_NAV_DBS
//#############################
function monthly_snap_retrieve_nav_dbs()
{
	//GRAB OUR NAV AND ERROR VIEW IDS
	var nav_view = document.getElementById('monthly_snapshot_nav');
	var error_view = document.getElementById('monthly_snapshot_error');

	//RETRIEVE SERVER INDEX
	var server_id_idx = document.getElementById('snap_servers').selectedIndex;

	//GET OUR VAR IDS
	var server_id = document.getElementById('snap_servers').value;
	var snap_nav_db_list = document.getElementById('snap_nav_db_list');
	var snap_nav_month_list = document.getElementById('snap_nav_month_list');
	var snap_nav_year_list = document.getElementById('snap_nav_year_list');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY AND HIDE ERROR
				error_view.innerHTML = '';
				error_view.style.display = 'none';

				//EMPTY AND HIDE THE DB DATA VAR
				snap_nav_db_list.style.innerHTML = '';
				snap_nav_db_list.style.display = 'none';

				//RESET MONTH AND YEAR
				snap_nav_month_list.innerHTML = '';
				snap_nav_month_list.style.display = 'none';
				snap_nav_year_list.innerHTML = '';
				snap_nav_year_list.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);

				//SUCCESS VAR STORED IN INDEX 0
				var success = json_array[0];

				if(success == 1)
				{
					var snap_nav_db_list_data = json_array[1];
					var snap_nav_month_list_data = json_array[2];
					var snap_nav_year_list_data = json_array[3];

					//UPDATE DB LIST IF NOT STATTING ALL SERVERS
					if(server_id_idx === 0)
					{
						snap_nav_db_list.innerHTML = '';
						snap_nav_db_list.style.display = 'none';
					}
					else
					{
						snap_nav_db_list.innerHTML = snap_nav_db_list_data;
						snap_nav_db_list.style.display = '';
					}

					//UPDATE MONTH AND YEAR LISTS
					snap_nav_month_list.innerHTML = snap_nav_month_list_data;
					snap_nav_month_list.style.display = '';
					snap_nav_year_list.innerHTML = snap_nav_year_list_data;
					snap_nav_year_list.style.display = '';
				}
				else
				{
					//RESET NAV
					nav_view.innerHTML = '';
					nav_view.style.display = 'none';

					//DISPLAY ERROR
					var response = json_array[1];
					error_view.innerHTML = response;
					error_view.style.display = '';
				}
			}
		};
	
		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=monthly_snap_retrieve_nav_dbs&server_id=" + server_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//##########################
//MONTHLY_SNAP_SELECT_NAV_DB
//##########################
function monthly_snap_select_nav_db()
{
	//GRAB OUR NAV AND ERROR VIEW IDS
	var nav_view = document.getElementById('monthly_snapshot_nav');
	var error_view = document.getElementById('monthly_snapshot_error');

	//GRAB OUR NECESSARY IDS NOW
	var server_id = document.getElementById('snap_servers').value;
	var db_id = document.getElementById('snap_dbs').value;
	var snap_nav_month_list = document.getElementById('snap_nav_month_list');
	var snap_nav_year_list = document.getElementById('snap_nav_year_list');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();
	
	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY AND HIDE ERROR
				error_view.innerHTML = '';
				error_view.style.display = 'none';

				//EMPTY AND HIDE THE DB DATA VAR
				snap_nav_month_list.innerHTML = '';
				snap_nav_month_list.style.display = 'none';
				snap_nav_year_list.innerHTML = '';
				snap_nav_year_list.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);

				//SUCCESS VAR STORED IN INDEX 0
				var success = json_array[0];

				if(success == 1)
				{
					//RETRIEVE MONTH / YEAR VARS
					var snap_nav_month_list_data = json_array[1];
					var snap_nav_year_list_data = json_array[2];

					//UPDATE VIEW NAV AND SHOW
					snap_nav_month_list.innerHTML = snap_nav_month_list_data;
					snap_nav_month_list.style.display = '';
					snap_nav_year_list.innerHTML = snap_nav_year_list_data;
					snap_nav_year_list.style.display = '';
				}
				else
				{
					//RESET NAV
					nav_view.innerHTML = '';
					nav_view.style.display = 'none';

					//DISPLAY ERROR
					var response = json_array[1];
					error_view.innerHTML = response;
					error_view.style.display = '';
				}
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=monthly_snap_select_nav_db&server_id=" + server_id + "&db_id=" + db_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//#####################
//MONTHLY_SNAP_RETRIEVE
//#####################
function monthly_snap_retrieve(month,year)
{
	//GET OUR VIEW IDS
	var monthly_snapshot = document.getElementById('monthly_snapshot');
	var monthly_snapshot_data = document.getElementById('monthly_snapshot_data');
	var error_view = document.getElementById('monthly_snapshot_error');
	var mem = document.getElementById('mem');

	//EMPTY OUT ERROR DIV
	error_view.innerHTML = '';
	error_view.style.display = 'none';

	//HANDLE MONTH AND YEAR INCOMING VARS
	if(month == null || year == null)
	{
		var month = document.getElementById('snap_month').value;
		var year = document.getElementById('snap_year').value;
	}
	else
	{
		//SET THE MENU ITEMS TO MATCH FOR THE VISITOR
		document.getElementById('snap_month').value = month;
		document.getElementById('snap_year').value = year;
	}

	//GET SERVERS VAR
	var servers = document.getElementById('snap_servers').value;

	//HANDLE DB VAR - ONLY USE IF LOADED UP
	if(document.getElementById('snap_dbs') != null)
	{
		var dbs = document.getElementById('snap_dbs').value;
	}

	//HANDLE CHARTTING VAR
	var snap_chartting = document.getElementById('snap_chartting').value;
	if(snap_chartting == 0)
	{
		document.getElementById('snap_chartting').value = 'commits';
		document.getElementById('snap_chartting').selectedIndex = 1;
		var snap_chartting = 'commits';
	}

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)
			{
				//CLEAR STAT VIEW
				clear_stat_views();

				//SHOW MAIN VIEW
				monthly_snapshot.style.display = '';

				//SHOW LOADING MSG AND MAKE DATA AREA VISIBLE
				monthly_snapshot_data.innerHTML = 'Loading Stats...';
				monthly_snapshot_data.style.display = '';

				//UPDATE PEAK SCRIPT MEM DIV
				mem.innerHTML = '';
				mem.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);

				//SUCCESS VAR STORED IN INDEX 0
				var success = json_array[0];
				var response = json_array[1];

				if(success == 1)
				{
					//SHOW OUR STATISTICS
					monthly_snapshot_data.innerHTML = response;

					//HANDLE OUR PEAK MEM USAGE
					var mem_response = json_array[2];
					if(typeof mem_response !== "undefined") { mem.innerHTML = "Script Peak Memory Usage: " + mem_response; mem.style.display = ''; }
				}
				else
				{
					//EMPTY OUT VIEW
					monthly_snapshot_data.innerHTML = '';

					//DISPLAY ERROR
					error_view.innerHTML = response;
					error_view.style.display = '';
				}
			}
		};
		
		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=monthly_snap_retrieve&servers=" + servers + "&dbs=" + dbs + "&month=" + month + "&year=" + year + "&snap_chartting=" + snap_chartting;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//########################
//DAILY_SELECT_NAV_SERVERS
//########################
function daily_select_nav_servers()
{
	//GRAB OUR NAV AND ERROR VIEW IDS
	var nav_view = document.getElementById('daily_nav');
	var error_view = document.getElementById('daily_error');

	//GET OUR VAR IDS
	var server_id = document.getElementById('daily_servers').value;
	var daily_nav_month_list = document.getElementById('daily_nav_month_list');
	var daily_nav_year_list = document.getElementById('daily_nav_year_list');

	//IF NOT ALL SERVERS SELECTED - FORCE REP MODE TO INDEX 0
	if(server_id != 0)
	{
		var daily_rep_mode = document.getElementById('daily_rep_mode');
		
		if(daily_rep_mode.value == 'combine')
		{	
			daily_rep_mode.value = 'split';
			daily_rep.selectedIndex = 0;
		}
	}

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY AND HIDE ERROR
				error_view.innerHTML = '';
				error_view.style.display = 'none';

				//RESET MONTH, DAY AND YEAR
				daily_nav_month_list.innerHTML = '';
				daily_nav_month_list.style.display = 'none';
				daily_nav_year_list.innerHTML = '';
				daily_nav_year_list.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);

				//SUCCESS VAR STORED IN INDEX 0
				var success = json_array[0];

				if(success == 1)
				{
					var daily_nav_month_list_data = json_array[1];
					var daily_nav_year_list_data = json_array[2];

					//UPDATE MONTH AND YEAR LISTS
					daily_nav_month_list.innerHTML = daily_nav_month_list_data;
					daily_nav_month_list.style.display = '';
					daily_nav_year_list.innerHTML = daily_nav_year_list_data;
					daily_nav_year_list.style.display = '';
				}
				else
				{
					//RESET NAV
					nav_view.innerHTML = '';
					nav_view.style.display = 'none';

					//DISPLAY ERROR
					var response = json_array[1];
					error_view.innerHTML = response;
					error_view.style.display = '';
				}
			}
		};
	
		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=daily_select_nav_servers&server_id=" + server_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//#####################
//DAILY_SELECT_REP_MODE
//#####################
function daily_select_rep_mode()
{
	//FORCE SERVERS TO ALL IF COMBINED IS SELECTED
	var daily_rep_mode = document.getElementById('daily_rep_mode');

	if(daily_rep_mode.value == 'combine')
	{
		var server_id = document.getElementById('daily_servers');

		if(server_id.value != 0)
		{	
			server_id.value = 0;
			server_id.selectedIndex = 0;
		}
	}
}

//##############
//DAILY_RETRIEVE
//##############
function daily_retrieve(month,day,year)
{
	//GET OUR VIEW IDS
	var daily = document.getElementById('daily');
	var daily_data = document.getElementById('daily_data');
	var error_view = document.getElementById('daily_error');
	var mem = document.getElementById('mem');

	//EMPTY OUT ERROR DIV
	error_view.innerHTML = '';
	error_view.style.display = 'none';

	//CHECK ON INCOMING MONTH, DAY AND YEAR VARS
	if(month == null || day == null || year == null)
	{
		var month = document.getElementById('daily_month').value;
		var day = document.getElementById('daily_day').value;
		var year = document.getElementById('daily_year').value;
	}
	else
	{
		//SET THE MENU ITEMS TO MATCH
		document.getElementById('daily_month').value = month;
		document.getElementById('daily_day').value = day;
		document.getElementById('daily_year').value = year;	
	}

	//GET SERVERS VAR
	var servers = document.getElementById('daily_servers').value;

	//HANDLE REP MODE
	var daily_rep_mode = document.getElementById('daily_rep_mode').value;
	if(daily_rep_mode == 0)
	{
		document.getElementById('daily_rep_mode').value = 'split';
		document.getElementById('daily_rep_mode').selectedIndex = 1;
		var daily_rep_mode = 'split';
	}
	else if(daily_rep_mode == 'combine')
	{
		//FORCE SERVER SELECTION TO ALL
		document.getElementById('daily_servers').value = 0;
		document.getElementById('daily_servers').selectedIndex = 0;
	}

	//HANDLE CHARTTING VAR
	var daily_chartting = document.getElementById('daily_chartting').value;
	if(daily_chartting == 0)
	{
		document.getElementById('daily_chartting').value = 'commits';
		document.getElementById('daily_chartting').selectedIndex = 1;
		var daily_chartting = 'commits';
	}

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//CLEAR STAT VIEW
				clear_stat_views();

				//SHOW MAIN VIEW
				daily.style.display = '';

				//SHOW LOADING MSG AND MAKE DATA AREA VISIBLE
				daily_data.innerHTML = 'Loading Stats...';
				daily_data.style.display = '';

				//UPDATE PEAK SCRIPT MEM DIV
				mem.innerHTML = '';
				mem.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);

				//SUCCESS VAR STORED IN INDEX 0
				var success = json_array[0];
				var response = json_array[1];

				if(success == 1)
				{
					//SHOW OUR STATISTICS
					daily_data.innerHTML = response;

					//HANDLE OUR PEAK MEM USAGE
					var mem_response = json_array[2];
					if(typeof mem_response !== "undefined") { mem.innerHTML = "Script Peak Memory Usage: " + mem_response; mem.style.display = ''; }
				}
				else
				{
					//EMPTY OUT VIEW
					daily_data.innerHTML = '';

					//DISPLAY ERROR
					error_view.innerHTML = response;
					error_view.style.display = '';
				}
			}
		};
		
		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=daily_retrieve&servers=" + servers + "&day=" + day + "&month=" + month + "&year=" + year + "&daily_chartting=" + daily_chartting + "&daily_rep_mode=" + daily_rep_mode;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//##############
//DAILY_EXTENDED
//##############
function daily_extended(i)
{
	if(document.getElementById(['daily_extended_' + i]) != null)
	{
		var daily_extended_div = document.getElementById(['daily_extended_' + i]);

		if(daily_extended_div.style.display == 'none')
		{
			daily_extended_div.style.display = '';
		}
		else
		{
			daily_extended_div.style.display = 'none';	
		}
	}
}

//#######################
//VERSUS_RETRIEVE_NAV_DBS
//#######################
function versus_retrieve_nav_dbs()
{
	//GRAB OUR NAV AND ERROR VIEW IDS
	var nav_view = document.getElementById('versus_nav');
	var error_view = document.getElementById('versus_error');

	//RETRIEVE SERVER INDEX
	var server_id_idx = document.getElementById('versus_servers').selectedIndex;

	//GET OUR VAR IDS
	var server_id = document.getElementById('versus_servers').value;
	var versus_nav_db_list = document.getElementById('versus_nav_db_list');
	var versus_nav_month_list_a = document.getElementById('versus_nav_month_list_a');
	var versus_nav_year_list_a = document.getElementById('versus_nav_year_list_a');
	var versus_nav_month_list_b = document.getElementById('versus_nav_month_list_b');
	var versus_nav_year_list_b = document.getElementById('versus_nav_year_list_b');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY AND HIDE ERROR
				error_view.innerHTML = '';
				error_view.style.display = 'none';

				//EMPTY AND HIDE THE DB DATA VAR
				versus_nav_db_list.style.innerHTML = '';
				versus_nav_db_list.style.display = 'none';

				//RESET MONTH AND YEAR
				versus_nav_month_list_a.innerHTML = '';
				versus_nav_month_list_a.style.display = 'none';
				versus_nav_year_list_a.innerHTML = '';
				versus_nav_year_list_a.style.display = 'none';
				versus_nav_month_list_b.innerHTML = '';
				versus_nav_month_list_b.style.display = 'none';
				versus_nav_year_list_b.innerHTML = '';
				versus_nav_year_list_b.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);

				//SUCCESS VAR STORED IN INDEX 0
				var success = json_array[0];

				if(success == 1)
				{
					var versus_nav_db_list_data = json_array[1];
					var versus_nav_month_list_data_a = json_array[2];
					var versus_nav_year_list_data_a = json_array[3];
					var versus_nav_month_list_data_b = json_array[4];
					var versus_nav_year_list_data_b = json_array[5];

					//UPDATE DB LIST IF NOT STATTING ALL SERVERS
					if(server_id_idx === 0)
					{
						versus_nav_db_list.innerHTML = '';
						versus_nav_db_list.style.display = 'none';
					}
					else
					{
						versus_nav_db_list.innerHTML = versus_nav_db_list_data;
						versus_nav_db_list.style.display = '';
					}

					//UPDATE MONTH AND YEAR LISTS
					versus_nav_month_list_a.innerHTML = versus_nav_month_list_data_a;
					versus_nav_month_list_a.style.display = '';
					versus_nav_year_list_a.innerHTML = versus_nav_year_list_data_a;
					versus_nav_year_list_a.style.display = '';
					versus_nav_month_list_b.innerHTML = versus_nav_month_list_data_b;
					versus_nav_month_list_b.style.display = '';
					versus_nav_year_list_b.innerHTML = versus_nav_year_list_data_b;
					versus_nav_year_list_b.style.display = '';
				}
				else
				{
					//RESET NAV
					nav_view.innerHTML = '';
					nav_view.style.display = 'none';

					//DISPLAY ERROR
					var response = json_array[1];
					error_view.innerHTML = response;
					error_view.style.display = '';
				}
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=versus_retrieve_nav_dbs&server_id=" + server_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//####################
//VERSUS_SELECT_NAV_DB
//####################
function versus_select_nav_db()
{
	//GRAB OUR NAV AND ERROR VIEW IDS
	var nav_view = document.getElementById('versus_nav');
	var error_view = document.getElementById('versus_error');

	//GRAB OUR NECESSARY IDS NOW
	var server_id = document.getElementById('versus_servers').value;
	var db_id = document.getElementById('versus_dbs').value;
	var versus_nav_month_list_a = document.getElementById('versus_nav_month_list_a');
	var versus_nav_year_list_a = document.getElementById('versus_nav_year_list_a');
	var versus_nav_month_list_b = document.getElementById('versus_nav_month_list_b');
	var versus_nav_year_list_b = document.getElementById('versus_nav_year_list_b');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY AND HIDE ERROR
				error_view.innerHTML = '';
				error_view.style.display = 'none';

				//EMPTY AND HIDE THE DB DATA VAR
				versus_nav_month_list_a.innerHTML = '';
				versus_nav_month_list_a.style.display = 'none';
				versus_nav_year_list_a.innerHTML = '';
				versus_nav_year_list_a.style.display = 'none';
				versus_nav_month_list_b.innerHTML = '';
				versus_nav_month_list_b.style.display = 'none';
				versus_nav_year_list_b.innerHTML = '';
				versus_nav_year_list_b.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);

				//SUCCESS VAR STORED IN INDEX 0
				var success = json_array[0];

				if(success == 1)
				{
					//RETRIEVE MONTH / YEAR VARS
					var versus_nav_month_list_data_a = json_array[1];
					var versus_nav_year_list_data_a = json_array[2];
					var versus_nav_month_list_data_b = json_array[3];
					var versus_nav_year_list_data_b = json_array[4];

					//UPDATE VIEW NAV AND SHOW
					versus_nav_month_list_a.innerHTML = versus_nav_month_list_data_a;
					versus_nav_month_list_a.style.display = '';
					versus_nav_year_list_a.innerHTML = versus_nav_year_list_data_a;
					versus_nav_year_list_a.style.display = '';
					versus_nav_month_list_b.innerHTML = versus_nav_month_list_data_b;
					versus_nav_month_list_b.style.display = '';
					versus_nav_year_list_b.innerHTML = versus_nav_year_list_data_b;
					versus_nav_year_list_b.style.display = '';
				}
				else
				{
					//RESET NAV
					nav_view.innerHTML = '';
					nav_view.style.display = 'none';

					//DISPLAY ERROR
					var response = json_array[1];
					error_view.innerHTML = response;
					error_view.style.display = '';
				}
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=versus_select_nav_db&server_id=" + server_id + "&db_id=" + db_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//###############
//VERSUS_RETRIEVE
//###############
function versus_retrieve()
{
	//GET OUR VIEW IDS
	var versus = document.getElementById('versus');
	var versus_data = document.getElementById('versus_data');
	var error_view = document.getElementById('versus_error');
	var mem = document.getElementById('mem');

	//EMPTY OUT ERROR DIV
	error_view.innerHTML = '';
	error_view.style.display = 'none';

	//MONTH AND YEAR ID VARS
	var month_a = document.getElementById('versus_month_a').value;
	var year_a = document.getElementById('versus_year_a').value;
	var month_b = document.getElementById('versus_month_b').value;
	var year_b = document.getElementById('versus_year_b').value;

	//GET SERVERS VAR
	var servers = document.getElementById('versus_servers').value;

	//HANDLE DB VAR - ONLY USE IF LOADED UP
	if(document.getElementById('versus_dbs') != null)
	{
		var dbs = document.getElementById('versus_dbs').value;
	}

	//HANDLE CHARTTING VAR
	var versus_chartting = document.getElementById('versus_chartting').value;
	if(versus_chartting == 0)
	{
		document.getElementById('versus_chartting').value = 'commits';
		document.getElementById('versus_chartting').selectedIndex = 1;
		var versus_chartting = 'commits';
	}

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)
			{
				//CLEAR STAT VIEW
				clear_stat_views();

				//SHOW MAIN VIEW
				versus.style.display = '';

				//SHOW LOADING MSG AND MAKE DATA AREA VISIBLE
				versus_data.innerHTML = 'Loading Stats...';
				versus_data.style.display = '';

				//UPDATE PEAK SCRIPT MEM DIV
				mem.innerHTML = '';
				mem.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);

				//SUCCESS VAR STORED IN INDEX 0
				var success = json_array[0];
				var response = json_array[1];

				if(success == 1)
				{
					//SHOW OUR STATISTICS
					versus_data.innerHTML = response;

					//HANDLE OUR PEAK MEM USAGE
					var mem_response = json_array[2];
					if(typeof mem_response !== "undefined") { mem.innerHTML = "Script Peak Memory Usage: " + mem_response; mem.style.display = ''; }
				}
				else
				{
					//EMPTY OUT VIEW
					versus_data.innerHTML = '';

					//DISPLAY ERROR
					error_view.innerHTML = response;
					error_view.style.display = '';
				}
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=versus_retrieve&servers=" + servers + "&dbs=" + dbs + "&month_a=" + month_a + "&year_a=" + year_a + "&month_b=" + month_b + "&year_b=" + year_b + "&versus_chartting=" + versus_chartting;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//#######################
//WEEKLY_RETRIEVE_NAV_DBS
//#######################
function weekly_retrieve_nav_dbs()
{
	//GRAB OUR NAV AND ERROR VIEW IDS
	var nav_view = document.getElementById('weekly_nav');
	var error_view = document.getElementById('weekly_error');

	//RETRIEVE SERVER INDEX
	var server_id_idx = document.getElementById('weekly_servers').selectedIndex;

	//GET OUR VAR IDS
	var server_id = document.getElementById('weekly_servers').value;
	var weekly_nav_db_list = document.getElementById('weekly_nav_db_list');
	var weekly_nav_month_list = document.getElementById('weekly_nav_month_list');
	var weekly_nav_year_list = document.getElementById('weekly_nav_year_list');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY AND HIDE ERROR
				error_view.innerHTML = '';
				error_view.style.display = 'none';

				//EMPTY AND HIDE THE DB DATA VAR
				weekly_nav_db_list.style.innerHTML = '';
				weekly_nav_db_list.style.display = 'none';

				//RESET MONTH AND YEAR
				weekly_nav_month_list.innerHTML = '';
				weekly_nav_month_list.style.display = 'none';
				weekly_nav_year_list.innerHTML = '';
				weekly_nav_year_list.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);

				//SUCCESS VAR STORED IN INDEX 0
				var success = json_array[0];

				if(success == 1)
				{
					var weekly_nav_db_list_data = json_array[1];
					var weekly_nav_month_list_data = json_array[2];
					var weekly_nav_year_list_data = json_array[3];

					//UPDATE DB LIST IF NOT STATTING ALL SERVERS
					if(server_id_idx === 0)
					{
						weekly_nav_db_list.innerHTML = '';
						weekly_nav_db_list.style.display = 'none';
					}
					else
					{
						weekly_nav_db_list.innerHTML = weekly_nav_db_list_data;
						weekly_nav_db_list.style.display = '';
					}

					//UPDATE MONTH AND YEAR LISTS
					weekly_nav_month_list.innerHTML = weekly_nav_month_list_data;
					weekly_nav_month_list.style.display = '';
					weekly_nav_year_list.innerHTML = weekly_nav_year_list_data;
					weekly_nav_year_list.style.display = '';
				}
				else
				{
					//RESET NAV
					nav_view.innerHTML = '';
					nav_view.style.display = 'none';

					//DISPLAY ERROR
					var response = json_array[1];
					error_view.innerHTML = response;
					error_view.style.display = '';
				}
			}
		};
	
		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=weekly_retrieve_nav_dbs&server_id=" + server_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//####################
//WEEKLY_SELECT_NAV_DB
//####################
function weekly_select_nav_db()
{
	//GRAB OUR NAV AND ERROR VIEW IDS
	var nav_view = document.getElementById('weekly_nav');
	var error_view = document.getElementById('weekly_error');

	//GRAB OUR NECESSARY IDS NOW
	var server_id = document.getElementById('weekly_servers').value;
	var db_id = document.getElementById('weekly_dbs').value;
	var weekly_nav_month_list = document.getElementById('weekly_nav_month_list');
	var weekly_nav_year_list = document.getElementById('weekly_nav_year_list');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();
	
	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY AND HIDE ERROR
				error_view.innerHTML = '';
				error_view.style.display = 'none';

				//EMPTY AND HIDE THE DB DATA VAR
				weekly_nav_month_list.innerHTML = '';
				weekly_nav_month_list.style.display = 'none';
				weekly_nav_year_list.innerHTML = '';
				weekly_nav_year_list.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);

				//SUCCESS VAR STORED IN INDEX 0
				var success = json_array[0];

				if(success == 1)
				{
					//RETRIEVE MONTH / YEAR VARS
					var weekly_nav_month_list_data = json_array[1];
					var weekly_nav_year_list_data = json_array[2];

					//UPDATE VIEW NAV AND SHOW
					weekly_nav_month_list.innerHTML = weekly_nav_month_list_data;
					weekly_nav_month_list.style.display = '';
					weekly_nav_year_list.innerHTML = weekly_nav_year_list_data;
					weekly_nav_year_list.style.display = '';
				}
				else
				{
					//RESET NAV
					nav_view.innerHTML = '';
					nav_view.style.display = 'none';

					//DISPLAY ERROR
					var response = json_array[1];
					error_view.innerHTML = response;
					error_view.style.display = '';
				}
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=weekly_select_nav_db&server_id=" + server_id + "&db_id=" + db_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//###############
//WEEKLY_RETRIEVE
//###############
function weekly_retrieve()
{
	//GET OUR VIEW IDS
	var weekly = document.getElementById('weekly');
	var weekly_data = document.getElementById('weekly_data');
	var error_view = document.getElementById('weekly_error');
	var mem = document.getElementById('mem');

	//EMPTY OUT ERROR DIV
	error_view.innerHTML = '';
	error_view.style.display = 'none';

	//HANDLE MONTH, YEAR & SERVER NAV VARS
	var month = document.getElementById('weekly_month').value;
	var year = document.getElementById('weekly_year').value;
	var servers = document.getElementById('weekly_servers').value;

	//HANDLE DB VAR - ONLY USE IF LOADED UP
	if(document.getElementById('weekly_dbs') != null)
	{
		var dbs = document.getElementById('weekly_dbs').value;
	}

	//HANDLE CHARTTING VAR
	var weekly_chartting = document.getElementById('weekly_chartting').value;
	if(weekly_chartting == 0)
	{
		document.getElementById('weekly_chartting').value = 'commits';
		document.getElementById('weekly_chartting').selectedIndex = 1;
		var weekly_chartting = 'commits';
	}

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)
			{
				//CLEAR STAT VIEW
				clear_stat_views();

				//SHOW MAIN VIEW
				weekly.style.display = '';

				//SHOW LOADING MSG AND MAKE DATA AREA VISIBLE
				weekly_data.innerHTML = 'Loading Stats...';
				weekly_data.style.display = '';

				//UPDATE PEAK SCRIPT MEM DIV
				mem.innerHTML = '';
				mem.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);

				//SUCCESS VAR STORED IN INDEX 0
				var success = json_array[0];
				var response = json_array[1];

				if(success == 1)
				{
					//SHOW OUR STATISTICS
					weekly_data.innerHTML = response;

					//HANDLE OUR PEAK MEM USAGE
					var mem_response = json_array[2];
					if(typeof mem_response !== "undefined") { mem.innerHTML = "Script Peak Memory Usage: " + mem_response; mem.style.display = ''; }
				}
				else
				{
					//EMPTY OUT VIEW
					weekly_data.innerHTML = '';

					//DISPLAY ERROR
					error_view.innerHTML = response;
					error_view.style.display = '';
				}
			}
		};
		
		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=weekly_retrieve&servers=" + servers + "&dbs=" + dbs + "&month=" + month + "&year=" + year + "&weekly_chartting=" + weekly_chartting;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//#######################
//YEARLY_RETRIEVE_NAV_DBS
//#######################
function yearly_retrieve_nav_dbs()
{
	//GRAB OUR NAV AND ERROR VIEW IDS
	var nav_view = document.getElementById('yearly_nav');
	var error_view = document.getElementById('yearly_error');

	//RETRIEVE SERVER INDEX
	var server_id_idx = document.getElementById('yearly_servers').selectedIndex;

	//GET OUR VAR IDS
	var server_id = document.getElementById('yearly_servers').value;
	var yearly_nav_db_list = document.getElementById('yearly_nav_db_list');
	var yearly_nav_year_list = document.getElementById('yearly_nav_year_list');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY AND HIDE ERROR
				error_view.innerHTML = '';
				error_view.style.display = 'none';

				//EMPTY AND HIDE THE DB DATA VAR
				yearly_nav_db_list.style.innerHTML = '';
				yearly_nav_db_list.style.display = 'none';

				//RESET YEAR
				yearly_nav_year_list.innerHTML = '';
				yearly_nav_year_list.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);

				//SUCCESS VAR STORED IN INDEX 0
				var success = json_array[0];

				if(success == 1)
				{
					var yearly_nav_db_list_data = json_array[1];
					var yearly_nav_year_list_data = json_array[2];

					//UPDATE DB LIST IF NOT STATTING ALL SERVERS
					if(server_id_idx === 0)
					{
						yearly_nav_db_list.innerHTML = '';
						yearly_nav_db_list.style.display = 'none';
					}
					else
					{
						yearly_nav_db_list.innerHTML = yearly_nav_db_list_data;
						yearly_nav_db_list.style.display = '';
					}

					//UPDATE YEAR LISTS
					yearly_nav_year_list.innerHTML = yearly_nav_year_list_data;
					yearly_nav_year_list.style.display = '';
				}
				else
				{
					//RESET NAV
					nav_view.innerHTML = '';
					nav_view.style.display = 'none';

					//DISPLAY ERROR
					var response = json_array[1];
					error_view.innerHTML = response;
					error_view.style.display = '';
				}
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=yearly_retrieve_nav_dbs&server_id=" + server_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//####################
//YEARLY_SELECT_NAV_DB
//####################
function yearly_select_nav_db()
{
	//GRAB OUR NAV AND ERROR VIEW IDS
	var nav_view = document.getElementById('yearly_nav');
	var error_view = document.getElementById('yearly_error');

	//GRAB OUR NECESSARY IDS NOW
	var server_id = document.getElementById('yearly_servers').value;
	var db_id = document.getElementById('yearly_dbs').value;
	var yearly_nav_year_list = document.getElementById('yearly_nav_year_list');

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();
	
	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)							
			{
				//EMPTY AND HIDE ERROR
				error_view.innerHTML = '';
				error_view.style.display = 'none';

				//EMPTY AND HIDE THE DB YEAR VAR
				yearly_nav_year_list.innerHTML = '';
				yearly_nav_year_list.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);

				//SUCCESS VAR STORED IN INDEX 0
				var success = json_array[0];

				if(success == 1)
				{
					//RETRIEVE YEAR VAR
					var yearly_nav_year_list_data = json_array[1];

					//UPDATE VIEW NAV AND SHOW
					yearly_nav_year_list.innerHTML = yearly_nav_year_list_data;
					yearly_nav_year_list.style.display = '';
				}
				else
				{
					//RESET NAV
					nav_view.innerHTML = '';
					nav_view.style.display = 'none';

					//DISPLAY ERROR
					var response = json_array[1];
					error_view.innerHTML = response;
					error_view.style.display = '';
				}
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=yearly_select_nav_db&server_id=" + server_id + "&db_id=" + db_id;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//###############
//YEARLY_RETRIEVE
//###############
function yearly_retrieve()
{
	//GET OUR VIEW IDS
	var yearly = document.getElementById('yearly');
	var yearly_data = document.getElementById('yearly_data');
	var error_view = document.getElementById('yearly_error');
	var mem = document.getElementById('mem');

	//EMPTY OUT ERROR DIV
	error_view.innerHTML = '';
	error_view.style.display = 'none';

	//HANDLE YEAR & SERVER NAV VARS
	var year = document.getElementById('yearly_year').value;
	var servers = document.getElementById('yearly_servers').value;

	//HANDLE DB VAR - ONLY USE IF LOADED UP
	if(document.getElementById('yearly_dbs') != null)
	{
		var dbs = document.getElementById('yearly_dbs').value;
	}

	//HANDLE CHARTTING VAR
	var yearly_chartting = document.getElementById('yearly_chartting').value;
	if(yearly_chartting == 0)
	{
		document.getElementById('yearly_chartting').value = 'commits';
		document.getElementById('yearly_chartting').selectedIndex = 1;
		var yearly_chartting = 'commits';
	}

	//CREATE OUR XMLHTTP OBJECT
	xmlHttp = GetXmlHttpObject();

	//MAKE SURE IT EXISTS
	if(xmlHttp == null) { alert ("Your browser does not support AJAX."); return; }
	else
	{
		xmlHttp.onreadystatechange = function()				
		{
			//ON REQUEST SET-UP
			if(xmlHttp.readyState == 1)
			{
				//CLEAR STAT VIEW
				clear_stat_views();

				//SHOW MAIN VIEW
				yearly.style.display = '';

				//SHOW LOADING MSG AND MAKE DATA AREA VISIBLE
				yearly_data.innerHTML = 'Loading Stats...';
				yearly_data.style.display = '';

				//UPDATE PEAK SCRIPT MEM DIV
				mem.innerHTML = '';
				mem.style.display = 'none';
			}

			//OBTAIN RESULT
			if(xmlHttp.readyState == 4)	
			{
				//PARSE OUR DATA HERE
				json_array = JSON.parse(xmlHttp.responseText);

				//SUCCESS VAR STORED IN INDEX 0
				var success = json_array[0];
				var response = json_array[1];

				if(success == 1)
				{
					//SHOW OUR STATISTICS
					yearly_data.innerHTML = response;

					//HANDLE OUR PEAK MEM USAGE
					var mem_response = json_array[2];
					if(typeof mem_response !== "undefined") { mem.innerHTML = "Script Peak Memory Usage: " + mem_response; mem.style.display = ''; }
				}
				else
				{
					//EMPTY OUT VIEW
					yearly_data.innerHTML = '';

					//DISPLAY ERROR
					error_view.innerHTML = response;
					error_view.style.display = '';
				}
			}
		};

		//CREATE PARAMS - CALL USING POST - SETUP HEADERS
		var params = "stat_function=yearly_retrieve&servers=" + servers + "&dbs=" + dbs + "&year=" + year + "&yearly_chartting=" + yearly_chartting;
		xmlHttp.open("POST","scripts/ps_core.php",true);
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", params.length);
		xmlHttp.setRequestHeader("Connection", "close");
		xmlHttp.send(params);
	}
}

//#######
//TOOLTIP
//#######
var tooltip=function()
{
	var id = 'tip';
	var top = -25;
	var left = 10;
	var maxw = 300;
	var fade_speed = 25;
	var fade_timer = 40;
	var alpha_end = 85;
	var alpha_start = 0;
	var x,h;
	var ie = document.all ? true : false;
	return{
		show:function(v,w)
		{
			if(x == null)
			{
				x = document.createElement('div');
				x.setAttribute('id',id);
				document.body.appendChild(x);
				x.style.opacity = 0;
				x.style.filter = 'alpha_start(opacity=0)';
				document.onmousemove = this.pos;
			}
			x.style.display = 'block';
			
			//#####################################################
			//BELOW USED TO DE-ENCODE STRING PARAMETER IF NECESSARY
			//#####################################################
			x.innerHTML = v;
			x.style.width = w ? w + 'px' : 'auto';
			if(!w && ie)
			{
				x.style.width = x.offsetWidth;
			}
			if(x.offsetWidth > maxw){x.style.width = maxw + 'px';}
			h = parseInt(x.offsetHeight) + top;
			clearInterval(x.fade_timer);
			x.fade_timer = setInterval(function(){tooltip.fade(1);},fade_timer);
		},
		pos:function(e)
		{
			var u = ie ? event.clientY + document.documentElement.scrollTop : e.pageY;
			var l = ie ? event.clientX + document.documentElement.scrollLeft : e.pageX;
			x.style.top = (u - h) + 'px';
			x.style.left = (l + left) + 'px';
		},
		fade:function(d)
		{
			var a = alpha_start;
			if((a != alpha_end && d == 1) || (a !== 0 && d == -1))
			{
				var i = fade_speed;
				if(alpha_end - a < fade_speed && d == 1)
				{
					i = alpha_end - a;
				}else if(alpha_start < fade_speed && d == -1)
				{
					i = a;
				}
				alpha_start = a + (i * d);
				x.style.opacity = alpha_start * .01;
				x.style.filter = 'alpha_start(opacity=' + alpha_start + ')';
			}
			else
			{
				clearInterval(x.fade_timer);
				if(d == -1){x.style.display = 'none';}
			}
		},
		hide:function()
		{
			clearInterval(x.fade_timer);
			x.fade_timer = setInterval(function(){tooltip.fade(-1);},fade_timer);
		}
	};
}();